import '../assets/css/sdpi.css';
import '../assets/css/styles.css';
import { default as EventEmitter } from 'eventemitter3';
import Details from "./elements/Details";
import HtmlElementInterface from "./HtmlElementInterface";
import ElementGroupInterface from './ElementGroupInterface';
import ElementInterface from './ElementInterface';
import Dropdown from './elements/Dropdown';
import Input from './elements/Input';
import { EventType } from './EventType';
import { FormDataType } from './FormDataType';
export default class FormBuilder<T extends FormDataType> {
    private readonly initialData;
    private elementBag;
    private eventEmitter;
    constructor(initialData: T);
    getFormData(): T;
    setFormData(data: T): void;
    appendTo(element: HTMLElement): void;
    addElement<K extends keyof T>(name: K, value: T[K] extends Record<string, string> ? ElementGroupInterface & {
        elements: {
            [x in keyof T[K]]: ElementInterface;
        };
    } : ElementInterface): void;
    addHtml(element: HtmlElementInterface): void;
    addHtmlElement(element: HTMLElement): void;
    createInput(): Input;
    createDropdown(): Dropdown;
    createDetails(): Details;
    on<K extends keyof Pick<EventType, 'change-settings' | 'click-link'>>(event: K, callback: EventEmitter.EventListener<EventType, K>): void;
    private addEventsToElement;
    private onChangeElementValue;
}
