import { default as EventEmitter } from 'eventemitter3';
import { EventType } from "../EventType";
import ElementInterface from '../ElementInterface';
import { ValueType } from './ValueType';
export default abstract class AbstractElement implements ElementInterface {
    private readonly htmlContainer;
    private label;
    private eventEmitter;
    private elementValue;
    constructor();
    get value(): ValueType;
    protected abstract getInput(): HTMLElement;
    getHtmlElement(): HTMLElement;
    setValue(value: ValueType): void;
    setLabel(label: string): this;
    showOn(callback: () => boolean): this;
    on<K extends keyof EventType>(eventname: K, callback: EventEmitter.EventListener<EventType, K>): void;
    reportSettingsChange(): void;
    protected createLabel(): HTMLElement | undefined;
    protected changeValue(value: string): void;
}
