import { is } from 'ts-type-guards';
import AbstractElement from './AbstractElement';
export default class Input extends AbstractElement {
    constructor() {
        super(...arguments);
        this.placeholder = '';
    }
    setPlaceholder(placeholder) {
        this.placeholder = placeholder;
        return this;
    }
    getInput() {
        if (!this.input) {
            this.input = document.createElement('input');
            this.input.classList.add('sdpi-item-value');
            this.input.addEventListener('input', (error) => this.onInput(error));
        }
        if (this.placeholder !== '') {
            this.input.placeholder = this.placeholder;
        }
        return this.input;
    }
    onInput(event) {
        if (is(HTMLInputElement)(event.target)) {
            this.changeValue(event.target.value);
        }
    }
}
